// $Id: Gandharva.h,v 1.20 2002/06/26 08:38:35 Yoshi Exp $
// Copyright (C) 2000-2002 HOSHINO Yoshifumi
// {vO̓t[E\tgEFAłBρEĔzz GNU GPL o[WQ
// i͂ȍ~jQƂĂB

#ifndef _H_GANDHARVA
#define _H_GANDHARVA

#include <windows.h>
#include "GandharvaSettings.h"

#include "PlayerDataContainer.h"
#include "Winamp3Func.h"
#include "WinampFunc.h"

#define WC_LSDESKTOP        "DesktopBackgroundClass"
#define WINDOWCLASS_DLL     "GandharvaClass"

#define MAGICDWORD         0x49474541

#define TIMERID		DWORD

enum {
  USERBM_TOGGLE,
  USERBM_SHOW,
  USERBM_HIDE,
  USERBM_TOGGLE_TIME,
  USERBM_DISPMENU,
  USERBM_SNDVOL,
  USERBM_TOGGLE_ONTOP,
  USERBM_ONTOP,
  USERBM_NOT_ONTOP
};

enum {
  USERBM_AMP_POWER=10000,
  USERBM_AMP_COMMANDEX
};

//Parse Click Map
#define PCM_OTHER 0x0000
#define PCM_TIME  0x0001
#define PCM_TITLE 0x0002


class Gandharva : public GandharvaSettings
{
public:
  Gandharva( HWND parent, HINSTANCE lsinstance );
  ~Gandharva();

  static void bangToggleVisible(HWND, const char *);
  static void bangToggleTime(HWND, const char *);
  static void bangShow(HWND, const char *);
  static void bangHide(HWND, const char *);
  static void bangDispMenu(HWND, const char *);
  static void bangRunSndvol(HWND, const char *);
  static void bangToggleOnTop(HWND, const char *);
  static void bangOnTop(HWND, const char *);
  static void bangNotOnTop(HWND, const char *);

  static void bangAmpPrev(HWND, const char *);
  static void bangAmpPlay(HWND, const char *);
  static void bangAmpPause(HWND, const char *);
  static void bangAmpStop(HWND, const char *);
  static void bangAmpNext(HWND, const char *);
  static void bangAmpPLEdit(HWND, const char *);
  static void bangAmpOpenFile(HWND, const char *);
  static void bangAmpPower(HWND, const char *);

  static void bangAmpCommand(HWND hwnd, const char *);

  //void on(UINT, WPARAM, LPARAM);
  LRESULT onUser(UINT, WPARAM, LPARAM);
  LRESULT onPaint(UINT, WPARAM, LPARAM);
  LRESULT onTimer(UINT, WPARAM, LPARAM);
  LRESULT onLmGetRevid(UINT, WPARAM, LPARAM);
  LRESULT onDisplayChange(UINT, WPARAM, LPARAM);
  LRESULT onMouse(UINT, WPARAM, LPARAM);
  LRESULT onCopyData(UINT, WPARAM, LPARAM);

private:

  CPlayerDataContainer *m_pPlayer;

  DWORD ParseClickMap(int x, int y);
  BOOL MyParseBangCommand(char *);
  void SetWndPos();
  static LRESULT CALLBACK WndProc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam);
  LRESULT WindowProc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam);

  LRESULT ParseAmpCommand(DWORD command);

  //timer id & func
  UINT m_rtimer,m_stimer,m_wtimer;

  int m_nWaitCounter;

  //CommandProvider Token
  int m_token;
};

#endif //_H_GANDHARVA
