// $Id: cmdprovider.cpp,v 1.3 2002/06/26 08:38:36 Yoshi Exp $
// Copyright (C) 2002 HOSHINO Yoshifumi
// {vO̓t[E\tgEFAłBρEĔzz GNU GPL o[WQ
// i͂ȍ~jQƂĂB

#include "cmdprovider.h"

#define CMDPROV_REVISION "$modified: <2002/06/20 16:18 +0900>"



//\zp
CommandProvider::CommandProvider()
{
  m_Token = 0;
}

CommandProvider::~CommandProvider()
{
  if(m_Token)
    Close();
}


//GandharvaɃf[^𑗂邽߂ɔF؂s
//s͔r̂
BOOL CommandProvider::Open(HWND owner)
{
  HWND hGandharva;
  CMDPROVIDERSTRUCT cmdprov;
  COPYDATASTRUCT cpdata;

  if(NULL == (hGandharva = ::FindWindow("GandharvaClass", NULL)))
    return FALSE;

  ZeroMemory(&cmdprov, sizeof(CMDPROVIDERSTRUCT));

  cpdata.cbData = sizeof(CMDPROVIDERSTRUCT);
  cpdata.dwData = 0;
  cpdata.lpData = &cmdprov;

  cmdprov.cbSize = sizeof(CMDPROVIDERSTRUCT);
  cmdprov.command= CMDPROV_COMMAND_OPEN;
  strncpy(cmdprov.version, CMDPROV_REVISION, sizeof(cmdprov.version));

  if(NULL != (m_Token = (int)SendMessage(hGandharva, WM_COPYDATA, (WPARAM)owner, (long)&cpdata))) {
    m_hClientWnd = owner;
    return TRUE;
  }
  return FALSE;
}


//Ɛ肵ĂgUNV
BOOL CommandProvider::Close()
{
  HWND hGandharva;
  CMDPROVIDERSTRUCT cmdprov;
  COPYDATASTRUCT cpdata;

  if(NULL == (hGandharva = ::FindWindow("GandharvaClass", NULL)))
    return FALSE;

  ZeroMemory(&cmdprov, sizeof(CMDPROVIDERSTRUCT));

  cpdata.cbData = sizeof(CMDPROVIDERSTRUCT);
  cpdata.dwData = 0;
  cpdata.lpData = &cmdprov;

  cmdprov.cbSize = sizeof(CMDPROVIDERSTRUCT);
  cmdprov.command= CMDPROV_COMMAND_CLOSE;
  cmdprov.token  = m_Token;
  strncpy(cmdprov.version, CMDPROV_REVISION, sizeof(cmdprov.version)-1);

  if(CMDPROV_STATUS_NOERROR == SendMessage(hGandharva, WM_COPYDATA, (WPARAM)NULL, (long)&cpdata)) {
    m_hClientWnd = 0;
    return TRUE;
  }
  return FALSE;
}


GCOMMAND CommandProvider::SendData(int status, int total, int elapsed, LPSTR title)
{
  HWND hGandharva;
  CMDPROVIDERSTRUCT cmdprov;
  COPYDATASTRUCT cpdata;

  if(NULL == (hGandharva = ::FindWindow("GandharvaClass", NULL)))
    return 0;

  ZeroMemory(&cmdprov, sizeof(CMDPROVIDERSTRUCT));

  cpdata.cbData = sizeof(CMDPROVIDERSTRUCT);
  cpdata.dwData = 0;
  cpdata.lpData = &cmdprov;

  cmdprov.cbSize = sizeof(CMDPROVIDERSTRUCT);
  cmdprov.command = CMDPROV_COMMAND_DATA;
  cmdprov.token   = m_Token;
  cmdprov.total   = total;
  cmdprov.elapsed = elapsed;
  cmdprov.status  = status;
  strncpy(cmdprov.version, CMDPROV_REVISION, sizeof(cmdprov.version));

  if(title)
    strncpy(cmdprov.title, title, sizeof(cmdprov.title)-1);
  else
    cmdprov.title[0] = '\0';

  return SendMessage(hGandharva, WM_COPYDATA, (WPARAM)NULL, (long)&cpdata);
}


//o[W`FbN
BOOL CommandProvider::IsCorrectVersion(LPSTR lpversion)
{
  if(strcmp(lpversion, CMDPROV_REVISION)) return FALSE;

  return TRUE;
}


//f[^i[p\̂ւ̃|C^Ԃ
// G[BAD VERSION
LPCMDPROVIDERSTRUCT CommandProvider::ParseCopyData(LPARAM lparam)
{
  COPYDATASTRUCT *cpdata = (COPYDATASTRUCT *)lparam;
  if(cpdata->cbData != sizeof(CMDPROVIDERSTRUCT))  return NULL;

  LPCMDPROVIDERSTRUCT lpcmdprov = (LPCMDPROVIDERSTRUCT)cpdata->lpData;
  if(lpcmdprov->cbSize != sizeof(CMDPROVIDERSTRUCT)) return NULL;

  if(strcmp(lpcmdprov->version, CMDPROV_REVISION)) return NULL;

  return lpcmdprov;
}
