// $Id: cmdprovider.h,v 1.5 2002/06/26 08:38:36 Yoshi Exp $
// Copyright (C) 2002 HOSHINO Yoshifumi
// {vO̓t[E\tgEFAłBρEĔzz GNU GPL o[WQ
// i͂ȍ~jQƂĂB

#if !defined(_H_CMDPROVIDER)
#define _H_CMDPROVIDER

#include <windows.h>

#define GCOMMAND LRESULT

enum {
  CMDPROV_COMMAND_OPEN,  
  CMDPROV_COMMAND_DATA,
  CMDPROV_COMMAND_CLOSE
};

enum {
  CMDPROV_STATUS_NOERROR=0,
  CMDPROV_STATUS_CONNECTION_REFUSED,
  CMDPROV_STATUS_BAD_TOKEN,
  CMDPROV_STATUS_BAD_VERSION
};

typedef struct {
  int cbSize;			/* size of struct						*/
  int command;			/* communication command				*/
  int token;			/* Identifer to communication			*/
  int status;			/* status. playing=1, pause=3, stop=0	*/
  int total;			/* size. playing item size in ms		*/
  int elapsed;			/* position of playing in ms			*/
  int reserve;
  char title[1024];		/* title in sz							*/
  char version[256];	/* version string for certification		*/
  char reserved[768];
} CMDPROVIDERSTRUCT, *LPCMDPROVIDERSTRUCT;



class CommandProvider
{
public:
  CommandProvider();
  ~CommandProvider();  
  
  BOOL Open(HWND hwnd);
  BOOL Close();

  GCOMMAND	SendData(int status, int total, int elapsed, LPSTR title);
  static BOOL IsCorrectVersion(LPSTR lpversion);
  static LPCMDPROVIDERSTRUCT ParseCopyData(LPARAM);

private:
  HWND m_hClientWnd;
  int m_Token;
};

#endif