//$Id: winampFunc.h,v 1.14 2002/03/18 09:46:59 yoshi Exp $
/*============================================================================

  Winamp control class header.
        copyright (C) 2000-2002 HOSHINO Yoshifumi,(Yoshi)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


============================================================================*/
#ifndef _CLASS_WINAMP_FUNCTION
#define _CLASS_WINAMP_FUNCTION

#include <windows.h>
#include "PlayerDataContainer.h"
#include "ampcmd.h"

#define WC_WINAMP2 "Winamp v1.x"
#define DEFAULT_WINAMP_SUFFIX "- Winamp"

#define GWT_REFRESH  TRUE
#define GWT_COPYONLY FALSE

#define IPC_ISPLAYING 104
#define IPC_GETOUTPUTTIME 105


class CWinampFunction : public CPlayerDataContainer
{
public:
  CWinampFunction(LPSTR DefaultStr =NULL, LPSTR DefaultPath=NULL);

  long GetPlaybackTime(DWORD mode);
  UINT GetPlaybackStatus();
  BOOL PostCommand(DWORD command);
  void SetFormat(LPSTR TitleBuffer, BOOL Prefix, BOOL Suffix);
  BOOL GetPath(LPSTR path);
  void GetWindowTitle(LPSTR TitleBuffer, size_t bufsize);
  void DisplayMainMenu();
};

#endif  //_CLASS_WINAMP_FUNCTION